import os
import sys


input_dir = "plot/triangle_reformatted/"
input_files = [input_dir + input_file for input_file in sorted(os.listdir(input_dir))]
P = len(input_files)

global_var = []
local_vars = []
border_vars = []
# max_upper_border, max_lower_border, max_local_elements, max_neumann_elements
max_var = [-1] * 4

for input_file in input_files:
	with open(input_file, 'r') as f:
		lines = [next(f).strip() for _ in range(3)]
		if (input_file == input_dir + "0.txt"):
			global_var = lines[0].split()
			global_var = [int(int_var) for int_var in global_var[:2]] + [float(float_var) for float_var in global_var[2:]]
		local_vars += [[int(var) for var in lines[1].split()]]
		border_vars += [[int(var) for var in lines[2].split()]]

max_var[0] = max([border_vars[i][0] for i in range(P)])
max_var[1] = max([border_vars[i][1] for i in range(P)])
max_var[2] = local_vars[0][2]
max_var[3] = max([local_vars[i][3] for i in range(P)])

# Find FLOP/BYTE
n_local = max_var[2]
n_border = max_var[0] + max_var[1]
n_neuman = max_var[3]
# Per time_step()
flop_tot = 18*(n_local+n_border+n_neuman) + 70*(n_local) + 49*(n_local)
mem_tot = (8*(n_neuman) + 22*(n_local+n_border+n_neuman) + 47*(n_local) + 36*(n_local)) * 8
flopbyte = float(flop_tot) / float(mem_tot)

filename = sys.argv[1] + 'v-' if len(sys.argv) > 1 else str(global_var[0]) + 'v-'
output_file = "out/structure/" + filename + str(P) + 'p.txt'
with open(output_file, 'w') as f:
	[print(var, end=' ', file=f) for var in global_var[:2]]
	[print('{0:.6f}'.format(var), end=" ", file=f) for var in global_var[2:]]
	print(file=f)
	[print(var, end=' ', file=f) for var in max_var]
	print(file=f)
	print(flop_tot, '(FLOP per time_step())', file=f)
	print(mem_tot, '(memory access per time_step())', file=f)
	print(flopbyte, 'FLOP/Byte', file=f)
	print(P, '(number of processes)', file=f)
	for i in range(P):
		print(input_files[i], end=' ', file=f)
		print(local_vars[i], end=' ', file=f)
		print(border_vars[i], file=f)

